import os

os.environ["CUDA_VISIBLE_DEVICES"] = "1"



import tensorflow as tf

import keras.backend.tensorflow_backend as KTF

config = tf.ConfigProto()

config.gpu_options.allow_growth=True   #不全部占满显存, 按需分配

#config.gpu_options.per_process_gpu_memory_fraction = 0.3 #指定分配30%空间

sess = tf.Session(config=config)# 设置session

KTF.set_session(sess)

from keras import backend as K
import numpy as np


from keras.models import  Model
from keras import activations
from keras.engine.topology import Layer

from keras.layers import LSTM,  Flatten,  Reshape,add
from keras.layers import Input, Dense,  concatenate

from keras.optimizers import Adam
from keras import metrics
from keras.layers.normalization import BatchNormalization


batch_size = 128
mean_label = 0.0
label_max = 0
label_min = 0
max_epoch = 10
num_feature = 100
seq_len = 3
hidden_dim = 512
threshold = 10.0
maxtruey = 0
mintruey = 0
eps = 1e-5
loss_lambda = 10.0
feature_len = 0
#******
local_image_size = 7
cnn_hidden_dim_first = 32
len_valid_id = 0
toponet_len = 32
LSTM_LEN = 11

sess = tf.Session()
K.set_session(sess)
def Conv2d_BN(x, nb_filter, kernel_size, strides=(1, 1), padding='same', name=None):
    if name is not None:
        bn_name = name + '_bn'
        conv_name = name + '_conv'
    else:
        bn_name = None
        conv_name = None

    x = Local_Seq_Conv(output_dim=1, seq_len=LSTM_LEN, feature_size=feature_len,
                             kernel_size=(3, 3, 1, 1), activation='relu',
                             kernel_initializer='glorot_uniform', bias_initializer='zeros', padding='same',
                             strides=(1, 1))(x)
    x = BatchNormalization(axis=3, name=bn_name)(x)
    return x
def identity_Block(inpt, nb_filter, kernel_size, strides=(1, 1), with_conv_shortcut=False):
    x = Conv2d_BN(inpt, nb_filter=nb_filter, kernel_size=kernel_size, strides=strides, padding='same')
    x = Conv2d_BN(x, nb_filter=nb_filter, kernel_size=kernel_size, padding='same')
    if with_conv_shortcut:
        shortcut = Conv2d_BN(inpt, nb_filter=nb_filter, strides=strides, kernel_size=kernel_size)
        x = add([x, shortcut])
        return x
    else:
        x = add([x, inpt])
        return x

class Local_Seq_Conv(Layer):

    def __init__(self, output_dim, seq_len, feature_size, kernel_size, activation=None,
                 kernel_initializer='glorot_uniform',
                 bias_initializer='zeros', padding='same', strides=(1, 1), **kwargs):
        super(Local_Seq_Conv, self).__init__(**kwargs)
        self.output_dim = output_dim
        self.seq_len = seq_len
        self.bias_initializer = bias_initializer
        self.kernel_size = kernel_size
        self.kernel_initializer = kernel_initializer
        self.padding = padding
        self.strides = strides
        self.activation = activations.get(activation)

    def build(self, input_shape):
        batch_size = input_shape[0]
        self.kernel = []
        self.bias = []
        for eachlen in range(self.seq_len):
            self.kernel += [self.add_weight(shape=self.kernel_size,
                                            initializer=self.kernel_initializer,
                                            trainable=True, name='kernel_{0}'.format(eachlen))]

            self.bias += [self.add_weight(shape=(self.kernel_size[-1],),
                                          initializer=self.bias_initializer,
                                          trainable=True, name='bias_{0}'.format(eachlen))]
        self.build = True

    def call(self, inputs):
        output = []
        for eachlen in range(self.seq_len):

            tmp = K.bias_add(K.conv2d(inputs[:, eachlen, :, :, :], self.kernel[eachlen],
                                      strides=self.strides, padding=self.padding), self.bias[eachlen])

            if self.activation is not None:
                output += [self.activation(tmp)]

        output = tf.stack(output, axis=1)
        return output

    def compute_output_shape(self, input_shape):
        return (input_shape[0], input_shape[1], input_shape[2], input_shape[3], self.output_dim)


def build_model(  feature_len=16):
    # X_train, Y_train, X_test, Y_test = Featureset_get()
    image_input = Input(shape=(seq_len, local_image_size,
                               local_image_size,1), name='cnn_input')
    spatial = Local_Seq_Conv(output_dim=cnn_hidden_dim_first, seq_len=seq_len, feature_size=feature_len,
                             kernel_size=(3, 3, 1, cnn_hidden_dim_first), activation='relu',
                             kernel_initializer='glorot_uniform', bias_initializer='zeros', padding='same',
                             strides=(1, 1))(image_input)
    spatial = BatchNormalization()(spatial)
    # spatial = Local_Seq_Pooling(seq_len=seq_len)(spatial)
    spatial = Local_Seq_Conv(output_dim=cnn_hidden_dim_first, seq_len=seq_len, feature_size=feature_len,
                             kernel_size=(3, 3, cnn_hidden_dim_first, cnn_hidden_dim_first), activation='relu',
                             kernel_initializer='glorot_uniform', bias_initializer='zeros', padding='same',
                             strides=(1, 1))(spatial)
    spatial = BatchNormalization()(spatial)
    # spatial = Local_Seq_Pooling(seq_len=seq_len)(spatial)
    spatial = Local_Seq_Conv(output_dim=cnn_hidden_dim_first, seq_len=seq_len, feature_size=feature_len,
                             kernel_size=(3, 3, cnn_hidden_dim_first, cnn_hidden_dim_first), activation='relu',
                             kernel_initializer='glorot_uniform', bias_initializer='zeros', padding='same',
                             strides=(1, 1))(spatial)
    # spatial = Local_Seq_Pooling(seq_len=seq_len)(spatial)
    # spatial = BatchNormalization()(spatial)
    # spatial = Local_Seq_Conv(output_dim=cnn_hidden_dim_first, seq_len=seq_len, feature_size=feature_len, kernel_size=(3, 3, cnn_hidden_dim_first, cnn_hidden_dim_first), activation='relu', kernel_initializer='glorot_uniform', bias_initializer='zeros', padding='same', strides=(1, 1))(spatial)
    # spatial = BatchNormalization()(spatial)
    # spatial = Local_Seq_Pooling(seq_len=seq_len)(spatial)
    # spatial = Local_Seq_Conv(output_dim=cnn_hidden_dim_first, seq_len=seq_len, feature_size=feature_len, kernel_size=(3, 3, cnn_hidden_dim_first, cnn_hidden_dim_first), activation='relu', kernel_initializer='glorot_uniform', bias_initializer='zeros', padding='same', strides=(1, 1))(spatial)
    spatial = Flatten()(spatial)
    spatial = Reshape(target_shape=(seq_len, -1))(spatial)
    spatial_out = Dense(units=64, activation='relu')(spatial)

    lstm_input = Input(shape=(LSTM_LEN, local_image_size,
                               local_image_size, 1), name='lstm_input')
    resnet_out=resnet_34(lstm_input)

    x = concatenate([spatial_out,resnet_out ], axis=-2)
    # lstm_out = Dense(units=128, activation=relu)(x)
    lstm_out = LSTM(units=hidden_dim, return_sequences=False, dropout=0)(x)

    # topo_input = Input(shape=(toponet_len,), dtype='float32', name='topo_input')
    # topo_emb = Dense(units=6, activation='tanh')(topo_input)
    # static_dynamic_concate = concatenate([lstm_out, topo_emb], axis=-1)

    res = Dense(units=1, activation='sigmoid')(lstm_out)
    model = Model(inputs=[image_input, lstm_input],
                  outputs=res)
    sgd = Adam(lr=0.001, beta_1=0.9, beta_2=0.999, epsilon=1e-08, decay=1e-6)
    model.compile(loss="MAE", optimizer=sgd,
                  metrics=[metrics.mae])
    model.summary()
    # from keras.utils import plot_model
    # plot_model(model, to_file='model.png')
    # model.fit([trainimage, trainX], trainY, batch_size=batch_size, epochs=max_epoch)
    # model.save('local_conv_lstm_total_embed.h5')
    return model
def resnet_34(input,classes=64):
    #inpt = Input(shape=(channel,width, height, None))
    inpt=input
    #x = ZeroPadding2D((3, 3))(inpt)

    #conv1
    x = Conv2d_BN(inpt, nb_filter=1, kernel_size=(3, 3), strides=(1,1), padding='same')
    #x = MaxPooling2D(pool_size=(3, 3), strides=(2, 2), padding='same')(x)

    #conv2_x
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))

    #conv3_x
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3), strides=(1, 1))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))

    #conv4_x
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3), strides=(1, 1))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))
    x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))
    # x = identity_Block(x, nb_filter=1, kernel_size=(3, 3))

    #conv5_x
    # x = identity_Block(x, nb_filter=64, kernel_size=(3, 3), strides=(1, 1), with_conv_shortcut=True)
    # x = identity_Block(x, nb_filter=64, kernel_size=(3, 3))
    # x = identity_Block(x, nb_filter=64, kernel_size=(3, 3))
    # x = AveragePooling2D(pool_size=(7, 7))(x)
    x = Flatten()(x)
    print(x.shape)
    x= Reshape(target_shape=(LSTM_LEN, -1))(x)
    x = Dense(units=64, activation='relu')(x)

    #model = Model(inputs=inpt, outputs=x)
    return x


dataX1 = np.load("./TempFile/dataX1_7.npy")
dataX2 = np.load("./TempFile/dataX2_7.npy")
dataY = np.load("./TempFile/dataY_7.npy")
dataX1=np.expand_dims(dataX1,axis=4)
dataX2=np.expand_dims(dataX2,axis=4)
model=build_model()
model.fit([dataX1, dataX2],dataY, batch_size=batch_size, epochs=max_epoch)
model.save('to.hdf5')


# ======================================

dataX1=np.load("./TempFile/testDataX1_7.npy")
dataX2=np.load("./TempFile/testDataX2_7.npy")
dataY=np.load("./TempFile/testDataY_7.npy")
dataX1=np.expand_dims(dataX1,axis=-1)
dataX2=np.expand_dims(dataX2,axis=-1)
dataY=np.load("./TempFile/testDataY_7.npy")

print(dataX1.shape)
print(dataX2.shape)
print(dataY.shape)
y_predict=[]

from sklearn.metrics import mean_squared_error

for i in range(int(len(dataX1)/1080)):
    y_predicttemp = model.predict([dataX1[i*1080:(i+1)*1080],dataX2[i*1080:(i+1)*1080]])
    # y_predicttemp = model.predict([dataX1[i * 1080:(i + 1) * 1080]])
    print(mean_squared_error(y_predicttemp,dataY[i*1080:(i+1)*1080]))
    y_predict+=list(y_predicttemp)
    print(i)

y_predict = np.array(y_predict)
np.save("./TempFile/y_predict_7.npy",y_predict)

print("==========MSE=========")
def MSE(origin,predict):
    n = len(origin)
    sum = 0
    nn =0
    for i in range(n):
        if origin[i] >0.1:
            sum += (origin[i]*115.8992-predict[i][0]*115.8992)**2
            nn += 1
    return sum/nn
print(MSE(dataY, y_predict))
print("==========MAPE=========")
def MAPE(origin,predict):
    n = len(origin)
    sum = 0
    nn =0
    for i in range(n):
        if origin[i] >0.1:
            sum += abs((origin[i]-predict[i][0]))/origin[i]
            nn += 1
    return sum/nn

print(MAPE(dataY, y_predict))