from sklearn.model_selection import ShuffleSplit
from sklearn.model_selection import GridSearchCV
from xgboost import XGBRegressor
import xgboost as xgb
import numpy as np
import time

dataX2 = np.load("../TempFile/dataX2.npy")
dataY = np.load("../TempFile/dataY.npy")
testDataX2=np.load("../TempFile/testDataX2.npy")
testDataY=np.load("../TempFile/testDataY.npy")
dataX2 = dataX2.reshape(dataX2.shape[0],891)
testDataX2 = testDataX2.reshape(testDataX2.shape[0],891)

xgboost_default_params = {
            # 'learning_rate': 0.09,
            # 'n_estimators': 90,
            # 'max_depth': 9,
            # 'min_child_weight': 5,  # 决定最小叶子节点样本权重和，如果一个叶子节点的样本权重和小于min_child_weight则拆分过程结束。
            # 'silent': 0,  # 输出运行信息
            # 'gamma': 0,
            # 'subsample': 0.85,
            # 'colsample_bytree': 0.75,
            # 'nthread': 18,  # 控制线程数量
            # 'max_delta_step': 0,
            # 'scale_pos_weight': 1,
            # 'objective': 'reg:squarederror',
            # 'reg_alpha': 1e-05,
            'learning_rate': 0.09,
            'n_estimators': 90,
            'max_depth': 9,
            'min_child_weight': 5,  # 决定最小叶子节点样本权重和，如果一个叶子节点的样本权重和小于min_child_weight则拆分过程结束。
            'silent': 0,  # 输出运行信息
            'gamma': 0,
            'subsample': 0.85,
            'colsample_bytree': 0.8,
            'nthread': 4,  # 控制线程数量
            'max_delta_step': 0,
            'scale_pos_weight': 1,
            'objective': 'reg:squarederror',
            'reg_alpha': 1e-5,
            # 'subsample':0.4,  # 用于训练模型的子样本占整个样本集合的比例。如果设置为0.5则意味着XGBoost将随机的冲整个样本集合中随机的抽取出50%的子样本建立树模型，这能够防止过拟合。
            # 'colsample_bytree': 0.9,  # 建立树时对特征随机采样的比例（作用于特征）典型值：0.5-1
            # 'max_depth':5, # 树的深度
            'gpu_id':1,
            'max_bin':16,
            'tree_method':'gpu_hist'
        }



# grid_params = dict(
#     #xgboost
#     # min_child_weight = list(range(1,6,2)),
#     # max_depth = list(range(3,10,2)),
#     # subsample=[i / 100.0 for i in range(75, 90, 5)],
#     # colsample_bytree=[i / 100.0 for i in range(75, 90, 5)],
#     # reg_alpha=[1e-5, 1e-2, 0.1, 1, 100],
#     # gamma = [i / 10.0 for i in range(0, 5)],
#     n_estimators = list(range(30,100,10)),
#     learning_rate=[i / 100.0 for i in range(1, 20, 4)],
# )
#
# xgb_model = xgb.XGBRegressor(**xgboost_default_params)
#
# cv_split = ShuffleSplit(n_splits=6, train_size=0.7, test_size=0.2)
#
# start = time.time()
# grid = GridSearchCV(xgb_model, grid_params, cv=cv_split, scoring='neg_mean_squared_error')
# X=dataX2[:10000]
# y=dataY[:10000]
# grid.fit(X,y);
# print('GridSearchCV process use %.2f seconds'%(time.time()-start))
# print(grid.best_params_)
# print(grid.best_score_)




xgb_model = xgb.XGBRegressor(**xgboost_default_params)
xgb_model.fit(dataX2,dataY)
y_predict=xgb_model.predict(testDataX2)
print(testDataY.shape,y_predict.shape)

print("==========MSE=========")
def MSE(origin,predict):
    n = len(origin)
    sum = 0
    nn =0
    for i in range(n):
        if origin[i] >0.1:
            sum += (origin[i]*115.8992-predict[i]*115.8992)**2
            nn += 1
    return sum/nn
print(MSE(testDataY, y_predict))
print("==========MAPE=========")
def MAPE(origin,predict):
    n = len(origin)
    sum = 0
    nn =0
    for i in range(n):
        if origin[i] >0.1:
            sum += abs((origin[i]-predict[i]))/origin[i]
            nn += 1
    return sum/nn

print(MAPE(testDataY, y_predict))
