import pymysql
import pandas as pd
import configparser

cf = configparser.ConfigParser()
cf.read("../GlobalConf.conf")

conn = pymysql.connect(
    host=cf.get("db", "host"),
    user=cf.get("db", "user"),
    password=cf.get("db", "password"),
    database=cf.get("db", "database"),
    charset=cf.get("db", "charset")
)

# 定义城市
city = cf.get("city", "city")

# 定义起止时间
startYear = cf.getint("time", "startYear")

# 定义文件名
filename = '../TempFile/{}-Review.csv'.format(city)


sql = "SELECT r.business_id, b.longitude, b.latitude, r.date  FROM review r LEFT JOIN business b ON b.business_id = r.business_id  WHERE b.city = \'{}\'  AND r.date >= \'{}/{}/01\'  AND r.date <= \'{}/{}/31\' ORDER BY r. date;".format(
        city, startYear, '1', startYear + 5, '12')

cursor = conn.cursor(cursor=pymysql.cursors.DictCursor)

# 拼接并执行sql语句
cursor.execute(sql)

results = cursor.fetchall()

cursor.close()


df = pd.DataFrame()

i = 0
for row in results:
    df = df.append(row, ignore_index=True)
    i += 1
    if i % 1000 == 0:
        print(i)

df.to_csv(filename, index=False)

conn.close()

# print("=================月份数据===================")
#
# for index in range(72):
#     tem = int(1 + index) % 12
#     curMon = str(tem if tem != 0 else 12)
#     tem2 = int(index // 12) + startYear
#     curYear = str(tem2)
#
#     # 获取一个光标
#     cursor = conn.cursor(cursor=pymysql.cursors.DictCursor)
#     # 定义将要执行的sql语句
#     sql = "SELECT r.business_id, b.longitude, b.latitude, r.date  FROM review r LEFT JOIN business b ON b.business_id = r.business_id  WHERE b.city = \'{}\'  AND r.date >= \'{}/{}/01\'  AND r.date <= \'{}/{}/31\' ORDER BY r. date;".format(
#         city, curYear, curMon , curYear, curMon)
#     # 拼接并执行sql语句
#     cursor.execute(sql)
#
#     results = cursor.fetchall()
#
#     cursor.close()
#     #conn.close()
#
#     df = pd.DataFrame()
#
#     i = 0
#     for row in results:
#         df = df.append(row, ignore_index=True)
#         i += 1
#         if i % 1000 == 0:
#             print(i)
#
#     df.to_csv(filename+"-"+curYear+"-"+curMon+".csv", index=False)
#
#
# print("=================年份数据===================")
# for index in range(1):
#     curYear = str(startYear+index+4)
#     sql = "SELECT r.business_id, b.longitude, b.latitude, r.date  FROM review r LEFT JOIN business b ON b.business_id = r.business_id  WHERE b.city = \'{}\'  AND r.date >= \'{}/{}/01\'  AND r.date <= \'{}/{}/31\' ORDER BY r. date;".format(
#         city, curYear, '2', curYear, '12')
#
#     cursor = conn.cursor(cursor=pymysql.cursors.DictCursor)
#
#     # 拼接并执行sql语句
#     cursor.execute(sql)
#
#     results = cursor.fetchall()
#
#     cursor.close()
#
#
#     df = pd.DataFrame()
#
#     i = 0
#     for row in results:
#         df = df.append(row, ignore_index=True)
#         i += 1
#         if i % 1000 == 0:
#             print(i)
#
#     df.to_csv(filename+"-"+curYear+".csv", index=False)
#
# conn.close()