import pymysql
import pandas as pd
import configparser

cf = configparser.ConfigParser()
cf.read("../GlobalConf.conf")

conn = pymysql.connect(
    host=cf.get("db", "host"),
    user=cf.get("db", "user"),
    password=cf.get("db", "password"),
    database=cf.get("db", "database"),
    charset=cf.get("db", "charset")
)

# 定义城市
city = cf.get("city", "city")

# 定义文件名
filename = '../TempFile/{}-Checkin.csv'.format(city)

# 获取一个光标
cursor = conn.cursor(cursor=pymysql.cursors.DictCursor)

# 定义将要执行的sql语句
sql = "select a.business_id,a.latitude,a.longitude,b.date,b.countnum from checkin b left join business a on a.business_id = b.business_id where a.city = \'{}\';".format(
    city)
# 拼接并执行sql语句
cursor.execute(sql)

results = cursor.fetchall()

cursor.close()
conn.close()

df = pd.DataFrame()

i = 0
for row in results:
    df = df.append(row, ignore_index=True)
    i += 1
    if i%1000==0 :
        print(i)

df.to_csv(filename, index=False)

