from math import radians, cos, sin, asin, sqrt, ceil
import pandas as pd
import numpy as np
import configparser
import sys
sys.path.append("..")
from util import geodistance,countMon,ifInDateScope,ifInArea

cf = configparser.ConfigParser()
cf.read("../../GlobalConf.conf")


gridData=np.load("../../TempFile/gridData.npy")


k = np.array([[[[0.0005, 0.0005, 0.0005, 0.0005, 0.0005, 0.0005, 0.0005],
                [0.0005, 0.0076, 0.0076, 0.0076, 0.0076, 0.0076, 0.0005],
                [0.0005, 0.0076, 0.0604, 0.0604, 0.0604, 0.0076, 0.0005],
                [0.0005, 0.0076, 0.0604, 0.3830, 0.0604, 0.0076, 0.0005],
                [0.0005, 0.0076, 0.0604, 0.0604, 0.0604, 0.0076, 0.0005],
                [0.0005, 0.0076, 0.0076, 0.0076, 0.0076, 0.0076, 0.0005],
                [0.0005, 0.0005, 0.0005, 0.0005, 0.0005, 0.0005, 0.0005],
                ]]])

def conv_forward(z, K, padding=(1, 1), strides=(1, 1)):
    """
    多通道卷积前向过程
    :param z: 卷积层矩阵,形状(N,C,H,W)，N为batch_size，C为通道数
    :param K: 卷积核,形状(C,D,k1,k2), C为输入通道数，D为输出通道数
    :param b: 偏置,形状(D,)
    :param padding: padding
    :param strides: 步长
    :return: 卷积结果
    """
    padding_z = np.pad(z, ((0, 0), (0, 0), (3, 3), (3, 3)), 'constant', constant_values=0)
    N, _, height, width = padding_z.shape
    C, D, k1, k2 = K.shape
    assert (height - k1) % strides[0] == 0, '步长不为1时，步长必须刚好能够被整除'
    assert (width - k2) % strides[1] == 0, '步长不为1时，步长必须刚好能够被整除'
    conv_z = np.zeros((N, D, 1 + (height - k1) // strides[0], 1 + (width - k2) // strides[1]))
    for n in np.arange(N):
        for d in np.arange(D):
            for h in np.arange(height - k1 + 1)[::strides[0]]:
                for w in np.arange(width - k2 + 1)[::strides[1]]:
                    conv_z[n, d, h // strides[0], w // strides[1]] = np.sum(
                        padding_z[n, :, h:h + k1, w:w + k2] * K[:, d])
    return conv_z



for i in range(len(gridData)):
    gridData[i] = np.squeeze(conv_forward(np.expand_dims(np.expand_dims(gridData[i],axis=0),axis=0),k))

#np.save("../TempFile/gridData2_7.npy",gridData)
print("max:",gridData.max())
gridData =  gridData/gridData.max()
dataX1=[]
dataX2=[]
dataY=[]
for i in range(0,24):
    data1=gridData[i]
    data2=gridData[i+12]
    data3=gridData[i+24]
    data4=gridData[i+25:i+36]
    label=gridData[i+36]
    for j in range(0,54):
        for m in range(0,94):
            dataX1.append([data1[j:j+7,m:m+7],data2[j:j+7,m:m+7],data3[j:j+7,m:m+7]])
            dataX2.append(data4[:,j:j+7,m:m+7])
            dataY.append(label[j+3,m+3])
dataX1=np.array(dataX1)
dataX2=np.array(dataX2)
dataY=np.array(dataY)


np.save("../TempFile/dataX1_7.npy",dataX1)
np.save("../TempFile/dataX2_7.npy",dataX2)
np.save("../TempFile/dataY_7.npy",dataY)


testDataX1=[]
testDataX2=[]
testDataY=[]
for i in range(24,34):
    data1=gridData[i]
    data2=gridData[i+12]
    data3=gridData[i+24]
    data4=gridData[i+25:i+36]
    label=gridData[i+36]
    for j in range(0,54):
        for m in range(0,94):
            testDataX1.append([data1[j:j+7,m:m+7],data2[j:j+7,m:m+7],data3[j:j+7,m:m+7]])
            testDataX2.append(data4[:,j:j+7,m:m+7])
            testDataY.append(label[j+3,m+3])
testDataX1=np.array(testDataX1)
testDataX2=np.array(testDataX2)
testDataY=np.array(testDataY)

np.save("../TempFile/testDataX1_7.npy",testDataX1)
np.save("../TempFile/testDataX2_7.npy",testDataX2)
np.save("../TempFile/testDataY_7.npy",testDataY)